﻿/*
 * Run Flash Checker
 * Author: Sascha Wolter
 */
function FlashChecker() {
}
FlashChecker.prototype.checkDocumentSettings = function (currentDocument) {
	var playerVersion = currentDocument.getPlayerVersion();
	var asVersion = currentDocument.asVersion;
	var fps = currentDocument.frameRate;
	var height = currentDocument.height;;
	var width = currentDocument.width;;
	if (playerVersion != "9") fl.trace("Warning: Wrong player version!");
	if (asVersion != 3) fl.trace("Warning: Wrong ActionScript version!");
	if (fps != 24) fl.trace("Warning: Wrong framerate!");
	if (height != 800) fl.trace("Warning: Wrong height!");
	if (width != 800) fl.trace("Warning: Wrong width!");	
}

FlashChecker.prototype.checkDocument = function (currentDocument) {
	fl.trace("Info: Document name is " + currentDocument.name);
	for (var i=0; i<currentDocument.timelines.length; i++) {
		this.checkTimeline(currentDocument.timelines[i]);
	}
}

FlashChecker.prototype.checkLibrary = function (currentDocument) {
	for (var i=0; i<currentDocument.library.items.length; i++) {
		if (currentDocument.library.items[i].itemType == "movie clip") {
			this.checkTimeline(currentDocument.library.items[i].timeline);
		}
	}
}

FlashChecker.prototype.checkTimeline = function (currentTimeline) {
	fl.trace("Info: Scene or Symbol name is " + currentTimeline.name);
	for (var i=0; i<currentTimeline.layers.length; i++) {
		this.checkLayer(currentTimeline.layers[i]);
	}
}

FlashChecker.prototype.checkLayer = function (currentLayer) {
	fl.trace("Info: Layer name is " + currentLayer.name);
	for (var i=0; i<currentLayer.frames.length; i++) {
		if (currentLayer.frames[i].startFrame == i) {
			this.checkKeyframe(currentLayer.frames[i], i);
		} else {
			continue;
		}
	}
}

FlashChecker.prototype.checkKeyframe = function (currentFrame, frameIndex) {
	fl.trace("Info: Frame number is " + (frameIndex+1));
	for (var i=0; i<currentFrame.elements.length; i++) {
		this.checkElement(currentFrame.elements[i]);
	}
}

FlashChecker.prototype.checkElement = function (currentElement) {
	fl.trace("Info: Element name is " + currentElement.name + "(" + currentElement.elementType + ")" );
	var topfraction = currentElement.top % 1;
	var leftfraction = currentElement.left % 1;
	if (topfraction != 0 || leftfraction != 0) fl.trace("Warning: Position is not snapped to pixels!");
}

// Clear output panel
fl.outputPanel.clear();

// Check Document
var checker = new FlashChecker();
var currentDocument = fl.getDocumentDOM();
checker.checkDocumentSettings(currentDocument);
checker.checkDocument(currentDocument);
checker.checkLibrary(currentDocument);

// Save result
fl.outputPanel.save(currentDocument.pathURI + ".log" ,false, false);